EmptyDataResponse:
  type: object
  properties:
    data:
      type: object
      nullable: true
      example: null
    meta:
      type: object
      description: Объект с мета-информацией
  required:
      - data

IdObject:
  type: object
  properties:
    id:
      type: integer
      description: id
      example: 1

File:
  type: object
  properties:
    path:
      type: string
      description: Путь к файлу относительно корня диска, идентификатор
    name:
      type: string
      description: Название файла с расширением
    url:
      type: string
      description: Ссылка

MultipartFileUploadRequest:
  type: object
  properties:
    file:
      type: string
      format: binary
      description: Загружаемый файл

PaginationTypeCursorEnum:
  type: string
  description: >
      * Pagination types:
      * `cursor` - Пагинация используя cursor
  enum:
      - cursor
  x-enum-varnames:
      - CURSOR

PaginationTypeOffsetEnum:
  type: string
  description: >
      * Pagination types:
      * `offset` - Пагинация используя offset
  enum:
      - offset
  x-enum-varnames:
      - OFFSET

PaginationTypeEnum:
  type: string
  description: >
      * Pagination types:
      * `cursor` - Пагинация используя cursor
      * `offset` - Пагинация используя offset
  enum:
      - cursor
      - offset
  x-enum-varnames:
      - CURSOR
      - OFFSET

RequestBodySort:
  type: array
  example: []
  items:
    type: string

RequestBodyInclude:
  type: array
  example: []
  items:
    type: string

RequestBodyPagination:
  oneOf:
    - $ref: '#/RequestBodyCursorPagination'
    - $ref: '#/RequestBodyOffsetPagination'

RequestBodyCursorPagination:
  type: object
  properties:
    cursor:
      type: string
      example: null
      nullable: true
    limit:
      type: integer
      example: 20
    type:
      $ref: '#/PaginationTypeEnum'
      example: "cursor"

RequestBodyOffsetPagination:
  type: object
  properties:
    limit:
      type: integer
      example: 20
    offset:
      type: integer
      example: 0
    type:
      $ref: '#/PaginationTypeEnum'
      example: "offset"

ResponseBodyPagination:
  oneOf:
    - $ref: '#/ResponseBodyCursorPagination'
    - $ref: '#/ResponseBodyOffsetPagination'

ResponseBodyCursorPagination:
  type: object
  properties:
    cursor:
      type: string
      example: "eyJpZCI6MTAsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0"
      nullable: true
    limit:
      type: integer
      example: 20
    next_cursor:
      type: string
      example: "eyJpZCI6MTAsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0"
      nullable: true
    previous_cursor:
      type: string
      example: "eyJpZCI6MTAsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0"
      nullable: true
    type:
      $ref: '#/PaginationTypeCursorEnum'
      example: "cursor"

FileProtected:
  type: object
  description: Информация о файле в виде объекта. Для потребителя неважно какие внутри ключи

ResponseBodyOffsetPagination:
  type: object
  properties:
    limit:
      type: integer
      example: 20
    offset:
      type: integer
      example: 0
    total:
      type: integer
      example: 253
    type:
      $ref: '#/PaginationTypeOffsetEnum'
      example: "offset"

Address:
  type: object
  properties:
    address_string:
      type: string
      description: Адрес одной строкой
    country_code:
      type: integer
      description: Код страны
    post_index:
      type: string
      description: Почтовый индекс
    region:
      type: string
      description: Регион
    region_type:
      type: integer
      description: Тип региона
    area:
      type: string
      description: Район в регионе
    city:
      type: string
      description: город/населенный пункт
    city_guid:
      type: string
      description: ФИАС id населенного пункта
    city_type:
      type: integer
      description: Тип города/населенного пункта
    street:
      type: string
      description: Улица
    street_type:
      type: integer
      description: Тип улицы
    house:
      type: string
      description: Дом
    block:
      type: string
      description: Строение/корпус
    flat:
      type: string
      description: Квартира/офис
    porch:
      type: string
      description: Подъезд
    intercom:
      type: string
      description: Домофон
    comment:
      type: string
      description: Комментарий
    geo_lat:
      type: number
      format: float
      description: Широта
    geo_lon:
      type: number
      format: float
      description: Долгота
